using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace NewtonComplex
{
    public partial class Form1 : Form
    {
        private const int size = 400;
        private Bitmap bitmap = new Bitmap(size, size);

        public Form1()
        {
            InitializeComponent();

            for (int i = 0; i < size; i++)
			{
			    for (int j = 0; j < size; j++)
			    {
    			    Complex z = new Complex(-3.0+6.0/(size-1.0)*i, 3.0-6.0/(size-1.0)*j);
                    for (int k = 0; k < 40; k++)
                    {
                        z = z-(z*z*z-new Complex(1,0))/(3.0*z*z);
			        }
                    Color c = Color.Red;
                    if (z.Re < 0)
                    {
                        if (z.Im > 0)
                        {
                            c = Color.Green;
                        }
                        else
                        {
                            c = Color.Blue;
                        }
                    }
                    bitmap.SetPixel(i,j,c);
			    } 
			}
        }

        protected override void OnPaint(PaintEventArgs e)
        {
 	        base.OnPaint(e);

            e.Graphics.DrawImage(bitmap, 20, 20);
        }

    }

    internal struct Complex
    {
        public double Im, Re;
        public Complex(double re, double im)
        {
            Re = re;
            Im = im;
        }
        static public Complex operator +(Complex z1, Complex z2)
        {
            return new Complex(z1.Re + z2.Re, z1.Im + z2.Im);
        }
        static public Complex operator -(Complex z1, Complex z2)
        {
            return new Complex(z1.Re - z2.Re, z1.Im - z2.Im);
        }
        static public Complex operator *(Complex z1, Complex z2)
        {
            return new Complex(z1.Re * z2.Re - z1.Im * z2.Im, z1.Re*z2.Im+z1.Im*z2.Re);
        }
        static public Complex operator *(double r, Complex z)
        {
            return new Complex(r * z.Re, r * z.Im);
        }
        static public Complex operator /(Complex z1, Complex z2)
        {
            double denominator = z2.Re * z2.Re + z2.Im * z2.Im;
            return (1.0 / denominator) * new Complex(z1.Re * z2.Re + z1.Im * z2.Im, z1.Im * z2.Re - z1.Re * z2.Im);
        }
    }
}